<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Insert_new_product_on_trip StructType
 * @subpackage Structs
 */
class Insert_new_product_on_trip_1 extends UpdatePlanning
{
    /**
     * The TripID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TripID;
    /**
     * The PlaceID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PlaceID;
    /**
     * The JobID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $JobID;
    /**
     * The Products
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfProductInsert
     */
    public $Products;
    /**
     * Constructor method for Insert_new_product_on_trip
     * @uses Insert_new_product_on_trip_1::setTripID()
     * @uses Insert_new_product_on_trip_1::setPlaceID()
     * @uses Insert_new_product_on_trip_1::setJobID()
     * @uses Insert_new_product_on_trip_1::setProducts()
     * @param string $tripID
     * @param string $placeID
     * @param string $jobID
     * @param \ArrayType\ArrayOfProductInsert $products
     */
    public function __construct($tripID = null, $placeID = null, $jobID = null, \ArrayType\ArrayOfProductInsert $products = null)
    {
        $this
            ->setTripID($tripID)
            ->setPlaceID($placeID)
            ->setJobID($jobID)
            ->setProducts($products);
    }
    /**
     * Get TripID value
     * @return string|null
     */
    public function getTripID()
    {
        return $this->TripID;
    }
    /**
     * Set TripID value
     * @param string $tripID
     * @return \StructType\Insert_new_product_on_trip_1
     */
    public function setTripID($tripID = null)
    {
        // validation for constraint: string
        if (!is_null($tripID) && !is_string($tripID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tripID, true), gettype($tripID)), __LINE__);
        }
        $this->TripID = $tripID;
        return $this;
    }
    /**
     * Get PlaceID value
     * @return string|null
     */
    public function getPlaceID()
    {
        return $this->PlaceID;
    }
    /**
     * Set PlaceID value
     * @param string $placeID
     * @return \StructType\Insert_new_product_on_trip_1
     */
    public function setPlaceID($placeID = null)
    {
        // validation for constraint: string
        if (!is_null($placeID) && !is_string($placeID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($placeID, true), gettype($placeID)), __LINE__);
        }
        $this->PlaceID = $placeID;
        return $this;
    }
    /**
     * Get JobID value
     * @return string|null
     */
    public function getJobID()
    {
        return $this->JobID;
    }
    /**
     * Set JobID value
     * @param string $jobID
     * @return \StructType\Insert_new_product_on_trip_1
     */
    public function setJobID($jobID = null)
    {
        // validation for constraint: string
        if (!is_null($jobID) && !is_string($jobID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($jobID, true), gettype($jobID)), __LINE__);
        }
        $this->JobID = $jobID;
        return $this;
    }
    /**
     * Get Products value
     * @return \ArrayType\ArrayOfProductInsert|null
     */
    public function getProducts()
    {
        return $this->Products;
    }
    /**
     * Set Products value
     * @param \ArrayType\ArrayOfProductInsert $products
     * @return \StructType\Insert_new_product_on_trip_1
     */
    public function setProducts(\ArrayType\ArrayOfProductInsert $products = null)
    {
        $this->Products = $products;
        return $this;
    }
}
